#pragma once

namespace f4ll {

template <typename T> class singleton
{
public:
    static T &instance()
    {
        static T instance;
        return instance;
    }

protected:
    singleton() = default;
    singleton(const singleton &) = delete;
    singleton &operator=(const singleton &) = delete;
    static T *m_instance;
};

template <typename T> T *singleton<T>::m_instance = nullptr;

} //  namespace f1ll {
